//****************************************************************************
//Copyright (C) 2005-2006 Beijing BlueDJ Technology Co.,Ltd. All rights reserved.

//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either version 2
//of the License, or (at your option) any later version.

//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.

//You should have received a copy of the GNU General Public License
//along with this program (in the file LICENSE.GPL); if not, write to the Free Software
//Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.

//Please visit http://www.bluedj.com for more infomation about us.
//Contact us at ggwizard@gmail.com or darkdong@gmail.com.
//****************************************************************************/

#ifndef DJMATRIXCANVASTEXT_H
#define DJMATRIXCANVASTEXT_H

#include <QtGui>
#include <Qt3Support>
#include "DJBaseGlobal.h"

class DJ_BASE_EXPORT DJMatrixCanvasText: public Q3CanvasText
{
public:
	enum Type {
		None
	};
	static const int RTTI;
	DJMatrixCanvasText( Q3Canvas *canvas, Type type = None, quint32 id = 0 );
	DJMatrixCanvasText( Q3Canvas *canvas, const QString& string, Type type = None, quint32 id = 0 );
	DJMatrixCanvasText( Q3Canvas *canvas, const QString& string, const QFont& font, Type type = None, quint32 id = 0 );
	virtual ~DJMatrixCanvasText();
	
	virtual int rtti() const;
	int	type() const { return m_type; }
	quint32	id() const { return m_id; }
	void setFont( const QFont & f );
	void setInnerMatrix( const QMatrix& matrix );
	void setExternalMatrix( const QMatrix& matrix );
	QSize	realSize() const;
	void matrimove(  double x, double y );
private:
	void init();
	
    int	m_type;
    quint32	m_id;
    
    QMatrix	m_innerMatrix,m_externalMatrix;
    double	m_x,m_y;
    QFont	m_font;
};
#endif
